#!/bin/bash
#
# create_mgen_support_files()
#
MGEN=mgen-gcc
create_mgen_support_files()
{
    for a in Makefile make.config make.config.h-directories make.config.file-list; do
        if [ -e ${a} ]; then
            chmod +w ${a}
            rm -f ${a}.original
            mv ${a} ${a}.original
            echo "Renamed ${a} to ${a}.original..."
        fi
    done
    echo "Creating ${MGEN} support files..."
    ${MGEN} -h > make.config
    find .  -type f -iname "*.h" -o -iname "*.hxx" | awk -F'/' '{for ( i = 2; i < NF; i++ ) { if ( i < (NF -1) ) printf "%s/", $i; else printf "%s", $i; } printf "\n"; } ' | sort | uniq | awk 'BEGIN { printf "-define-search-path 01 /usr/include\n"; } { if ( length( $1 ) == 0 ) ptr = "."; else ptr = $1; printf "+define-search-path 01 %s\n", ptr;}' > make.config.h-directories


    echo "# +--------------+--------+------+-----------+--------+-----------+---+---+---+" >  make.config.file-list
    echo "# |              | group  |      | objects'  |        | search    |res|res|res|" >> make.config.file-list
    echo "# | keyword      | number | path | extention | recipe | includes? |vd1|vd2|vd3|" >> make.config.file-list
    echo "# +--------------+--------+------+-----------+--------+-----------+---+---+---+" >> make.config.file-list
    echo "-define-group       01       01        o         1         1        0   0   0  " >> make.config.file-list
    echo ""                                                                                >> make.config.file-list

    find . -type f \( -iname "*.c" -o -iname "*.cpp" -o -iname "*.cxx" -o -iname "*.CC" \) | awk -F'/' '{for ( i = 2; i <= NF - 1; i++ ) { printf "%s/", $i; } printf "%s\n", $NF; }' | sort | uniq | awk '{printf "+define-group       01                                              0   0   0   %s\n", $1;}' >> make.config.file-list

    echo ""
    echo -n "Would you like to generate the \"Makefile\" now? [y|Y|n|N] "
    read response
    if [ ${response} == "y" -o ${response} == "Y" ]; then
        echo "Creating project dependencies..."
        ${MGEN} make.config make.config.h-directories make.config.file-list
    fi
    echo ""
    echo "Next time you wish to generate the \"Makefile\", run the following command:"
    echo ""
    echo "    ${MGEN} make.config make.config.h-directories make.config.file-list"
    echo ""
}

create_mgen_support_files

